Index: src/interfaces/jdbc/org/postgresql/jdbc2/AbstractJdbc2ResultSet.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/jdbc2/AbstractJdbc2ResultSet.java,v
retrieving revision 1.25.2.1
diff -c -r1.25.2.1 AbstractJdbc2ResultSet.java
*** src/interfaces/jdbc/org/postgresql/jdbc2/AbstractJdbc2ResultSet.java	12 Dec 2003 18:38:19 -0000	1.25.2.1
--- src/interfaces/jdbc/org/postgresql/jdbc2/AbstractJdbc2ResultSet.java	18 Dec 2003 00:05:17 -0000
***************
*** 493,498 ****
--- 493,499 ----
  		if (--current_row < 0)
  			return false;
  		this_row = (byte[][]) rows.elementAt(current_row);
+ 		rowBuffer = new byte[this_row.length][];
  		System.arraycopy(this_row, 0, rowBuffer, 0, this_row.length);
  		return true;
  	}
Index: src/interfaces/jdbc/org/postgresql/test/jdbc2/ResultSetTest.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/test/jdbc2/ResultSetTest.java,v
retrieving revision 1.11
diff -c -r1.11 ResultSetTest.java
*** src/interfaces/jdbc/org/postgresql/test/jdbc2/ResultSetTest.java	23 Sep 2003 06:11:06 -0000	1.11
--- src/interfaces/jdbc/org/postgresql/test/jdbc2/ResultSetTest.java	18 Dec 2003 00:05:17 -0000
***************
*** 83,88 ****
--- 83,98 ----
  		TestUtil.closeDB(con);
  	}
  
+ 	public void testBackward() throws Exception
+ 	{
+ 		Statement stmt = con.createStatement();
+ 		ResultSet rs = stmt.executeQuery("SELECT * FROM testrs");
+ 		rs.afterLast();
+ 		assertTrue(rs.previous());
+ 		rs.close();
+ 		stmt.close();
+ 	}
+ 
  	public void testAbsolute() throws Exception
  	{
  		Statement stmt = con.createStatement();
